 /* stod - convert Fortran program from single-precision to double-precision */
%{
#include "flex.h"
#include "fortran.h"
int debug = 0;				/* non-zero for debug output when */
					/* compiled with -DDEBUG */
int dp_output = 1;			/* double-precision output */
%}
		/* increase lex table sizes for lex */
%a 4500
%e 1500
%k 1500
%n  500
%o 9500
%p 3000

a	[aA]
b	[bB]
c	[cC]
d	[dD]
e	[eE]
f	[fF]
g	[gG]
h	[hH]
i	[iI]
j	[jJ]
k	[kK]
l	[lL]
m	[mM]
n	[nN]
o	[oO]
p	[pP]
q	[qQ]
r	[rR]
s	[sS]
t	[tT]
u	[uU]
v	[vV]
w	[wW]
x	[xX]
y	[yY]
z	[zZ]
				    /* digits with optional embedded blanks */
B		([0-9]|[0-9][0-9 ]*[0-9])
					/* decimal digit */
D		[0-9]
					/* floating-point exponent */
E		[DEde][-+]?{B}
					/* optional whitespace */
W		[ \t]*
					/* number */
N		{B}
%%
^[*Cc].*$			ECHO;	/* copy comments unchanged */

^\t[1-9]			{	/* handle tabbed continuation */
				    outstr("     ");
				    output(yytext[1]);
				}

^\t0 |
^\t				outstr("      "); /* handle tabbed initial */

^{W}{r}{e}{a}{l}"*"8		convert_declaration();

^{W}{r}{e}{a}{l}"*"4 |
^{W}{r}{e}{a}{l}/[^*a-zA-Z]	convert_declaration();

^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{r}{e}{a}{l}"*"8		convert_declaration();

^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{r}{e}{a}{l}"*"4 |
^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{r}{e}{a}{l}/[^*a-zA-Z]	convert_declaration();

^"     "[^ 0]			ECHO;	/* copy continuation line prefixes */

{N}{p}{N}*[A-Za-z]{N}"."{N}	ECHO;	/* copy FORMAT items intact */

{N}*[A-Za-z]{N}"."{N}		ECHO;	/* copy FORMAT items intact */

"."{n}{o}{t}"." |
"."{a}{n}{d}"." |
"."{x}{o}{r}"." |
"."{o}{r}"." |
"."{g}{e}"." |
"."{g}{t}"." |
"."{l}{e}"." |
"."{l}{t}"." |
"."{e}{q}"." |
"."{e}{q}{v}"." |
"."{n}{e}"." |
"."{n}{e}{q}"."			ECHO;	/* recognize logical operators */

{N}"."{N}*({W}{E})? |
{N}*"."{N}({W}{E})? |
{N}{W}{E}			convert_number() ;

{i}{f}{i}{x}/{W}"("		cvtstr("idint"); /* handle name conversions */
{i}{n}{t}/{W}"("		cvtstr("idint");
{n}{i}{n}{t}/{W}"("		cvtstr("idnint");
{s}{n}{g}{l}/{W}"("		cvtstr("dble");
{a}{i}{n}{t}/{W}"("		cvtstr("dint");
{a}{l}{o}{g}/{W}"("		cvtstr("dlog");
{a}{l}{o}{g}10/{W}"("		cvtstr("dlog10");
{a}{m}{a}{x}0/{W}"("		cvtstr("dmax0");
{a}{m}{a}{x}1/{W}"("		cvtstr("dmax1");
{a}{m}{i}{n}0/{W}"("		cvtstr("dmin0");
{a}{m}{i}{n}1/{W}"("		cvtstr("dmin1");
{a}{m}{o}{d}/{W}"("		cvtstr("dmod");
{a}{n}{i}{n}{t}/{W}"("		cvtstr("dnint");
{a}{b}{s}/{W}"("		cvtstr("dabs");
{a}{c}{o}{s}/{W}"("		cvtstr("dacos");
{a}{s}{i}{n}/{W}"("		cvtstr("dasin");
{a}{t}{a}{n}/{W}"("		cvtstr("datan");
{a}{t}{a}{n}2			cvtstr("datan2");
{c}{o}{s}/{W}"("		cvtstr("dcos");
{c}{o}{s}{h}/{W}"("		cvtstr("dcosh");
{d}{i}{m}/{W}"("		cvtstr("ddim");
{e}{x}{p}/{W}"("		cvtstr("dexp");
{f}{l}{o}{a}{t}/{W}"("		cvtstr("dfloat");
{s}{i}{g}{n}/{W}"("		cvtstr("dsign");
{s}{i}{n}/{W}"("		cvtstr("dsin");
{s}{i}{n}{h}/{W}"("		cvtstr("dsinh");
{s}{q}{r}{t}/{W}"("		cvtstr("dsqrt");
{t}{a}{n}/{W}"("		cvtstr("dtan");
{t}{a}{n}{h}/{W}"("		cvtstr("dtanh");

{r}{a}{n}{d}/{W}"("		cvtstr("drand");	/* common extensions */
{r}{1}{m}{a}{c}{h}/{W}"("	cvtstr("d1mach");

{B}{W}{h}			outhollerith();

'[^']*(''[^']*)*'		outquotedstring();

[A-Za-z][A-Za-z0-9]+ |
[0-9]+ |
\n |
.				ECHO;
%%

int our_input(void)
{
    return (input());
}
